use crate::{deck::Deck, player::Player};

pub struct Lobby {
    players: Vec<Player>,
    deck: Deck,
}

impl Lobby {
    pub fn new() -> Lobby {
        let players: Vec<Player> = Vec::new();
        let deck = Deck::new().shuffle();

        Lobby {
            players,
            deck,
        }
    }

    pub fn join_lobby(mut self, player: Player) {
        self.players.push(player);
    }

    pub fn get_players(self) -> Vec<Player> {
        self.players
    }

    pub fn get_deck(self) -> Deck {
        self.deck
    }
}
